#ifndef _iflCdefs_h_
#define _iflCdefs_h_
#include <fcntl.h>
#include <stdarg.h>
#include <ifl/iflTypes.h>
#include <ifl/iflError.h>
#include <ifl/iflTile.h>
#include <ifl/iflSize.h>
#include <ifl/iflDataSize.h>
#include <ifl/iflCoord.h>
#include <ifl/iflTag.h>
typedef void iflColormap;
typedef void iflConfig;
typedef void iflDatabase;
typedef void iflFile;
typedef void iflFileConfig;
typedef void iflFileDesc;
typedef void iflFormat;
typedef void iflLut;
typedef void iflPixel;
typedef void iflSGIColormap;
typedef enum iflTagFlags iflTagFlags;
typedef void iflTag;
iflColormap *iflColormapCreate(int, iflDataType, int, int);
iflColormap *iflColormapNoAlloc(void *, int, iflDataType, int, int);
iflConfig *iflConfigCreate(iflDataType, iflOrder, int, int *, int, iflOrientation);
void iflConfigDelete(iflConfig *);
iflDatabase* iflDatabaseFindNext(int *);
iflDatabase* iflDatabaseFindByMagic(int);
iflDatabase* iflDatabaseFindByFormatName(const char *);
iflDatabase* iflDatabaseFindByFileName(const char *, int);
const char* iflDatabaseGetName(iflDatabase *);
const char* iflDatabaseGetDefaultSuffix(iflDatabase *);
const char* iflDatabaseGetDescription(iflDatabase *);
int iflDatabaseAccessModeIsSupported(iflDatabase *, int);
const char* iflDatabaseGetDSOName(iflDatabase *);
const char* iflDatabaseGetInstSubSystem(iflDatabase *);
iflFormat* iflDatabaseGetFormat(iflDatabase *, int);
iflFile* iflFileOpenPreParsed(iflFileDesc *, int, iflStatus *);
iflFile* iflFileOpenByDescriptor(int, const char *, int, iflFormat *, iflStatus *);
iflFile* iflFileOpen(const char *, int, iflStatus *);
iflFile* iflFileCreate(const char *, iflFile *, const iflFileConfig *, iflFormat *, iflStatus *);
iflFile* iflFileCreateByDescriptor(int, const char *, iflFile *, const iflFileConfig *, iflFormat *, iflStatus *);
iflFile* iflFileCreatePreParsed(iflFileDesc *, iflFile *, const iflFileConfig *, iflStatus *);
iflStatus iflFileClose(iflFile *, int);
iflStatus iflFileFlush(iflFile *);
char* iflFileParseFileName(const char *, char * *, int *, char * *);
iflStatus iflFileGetTile(iflFile *, int, int, int, int, int, int, void *, const iflConfig *);
iflStatus iflFileSetTile(iflFile *, int, int, int, int, int, int, const void *, const iflConfig *);
iflStatus iflFileGetPage(iflFile *, void *, int, int, int, int, int, int, int, int);
iflStatus iflFileSetPage(iflFile *, const void *, int, int, int, int, int, int, int, int);
int iflFileGetNumImgs(iflFile *);
int iflFileGetCurrentImg(iflFile *);
iflStatus iflFileSetCurrentImg(iflFile *, int);
iflStatus iflFileAppendImg(iflFile *, iflFile *, iflFileConfig *);
const char* iflFileGetFileName(iflFile *);
int iflFileGetFileDesc(iflFile *);
int iflFileGetFileMode(iflFile *);
iflFormat* iflFileGetFormat(iflFile *);
iflColorModel iflFileGetColorModel(iflFile *);
int* iflFileGetChannelPermutation(iflFile *);
void iflFileGetDimensions(iflFile *, iflSize *);
void iflFileGetSize(iflFile *, iflSize *, iflOrientation);
int iflFileGetZsize(iflFile *);
int iflFileGetCsize(iflFile *);
iflDataType iflFileGetDataType(iflFile *);
iflOrder iflFileGetOrder(iflFile *);
void iflFileGetPageDimensions(iflFile *, iflSize *);
void iflFileGetPageSize(iflFile *, iflSize *, iflOrientation);
iflOrientation iflFileGetOrientation(iflFile *);
iflCompression iflFileGetCompression(iflFile *);
iflStatus iflFileGetColormap(iflFile *, const iflColormap * *);
iflStatus iflFileGetStatMinMax(iflFile *, double *, double *);
iflStatus iflFileGetScaleMinMax(iflFile *, double *, double *);
iflStatus iflFileSetColormap(iflFile *, const iflColormap *);
iflStatus iflFileSetStatMinMax(iflFile *, double, double);
iflStatus iflFileSetScaleMinMax(iflFile *, double, double);
iflStatus iflFileGetTagV(iflFile *, int, va_list);
iflStatus iflFileSetTagV(iflFile *, int, va_list);
int iflFileHaveAttributesChanged(iflFile *);
iflStatus iflFileGetItemV(iflFile *, int, va_list);
iflStatus iflFileSetItemV(iflFile *, int, va_list);
iflStatus iflFileGetICCProfile(iflFile *, int *, void * *);
iflStatus iflFileFreeICCProfile(iflFile *, void *);
iflStatus iflFileSetICCProfile(iflFile *, int, const void *);
iflStatus iflFileEnableDirectIO(iflFile *, int);
iflStatus iflFileGetDirectIOMemAlignment(iflFile *, size_t *);
iflFileConfig *iflFileConfigCreate(const iflSize *, iflDataType, iflOrder, iflColorModel, iflOrientation, iflCompression, const iflSize *);
iflFileConfig *iflFileConfigFile(iflFile *);
void iflFileConfigReset(iflFileConfig *);
void iflFileConfigSetDimensions(iflFileConfig *, const iflSize *);
void iflFileConfigSetDataType(iflFileConfig *, iflDataType);
void iflFileConfigSetOrder(iflFileConfig *, iflOrder);
void iflFileConfigSetColorModel(iflFileConfig *, iflColorModel);
void iflFileConfigSetOrientation(iflFileConfig *, iflOrientation);
void iflFileConfigSetCompression(iflFileConfig *, iflCompression);
void iflFileConfigSetPageDimensions(iflFileConfig *, const iflSize *);
void iflFileConfigGetDimensions(iflFileConfig *, iflSize *);
const iflSize* iflFileConfigGetDimensionsPtr(iflFileConfig *);
void iflFileConfigGetSize(iflFileConfig *, iflSize *);
iflDataType iflFileConfigGetDataType(iflFileConfig *);
iflOrder iflFileConfigGetOrder(iflFileConfig *);
iflColorModel iflFileConfigGetColorModel(iflFileConfig *);
iflOrientation iflFileConfigGetOrientation(iflFileConfig *);
iflCompression iflFileConfigGetCompression(iflFileConfig *);
void iflFileConfigGetPageDimensions(iflFileConfig *, iflSize *);
const iflSize* iflFileConfigGetPageDimensionsPtr(iflFileConfig *);
void iflFileConfigGetPageSize(iflFileConfig *, iflSize *);
int iflFileConfigAreDimensionsDefaulted(iflFileConfig *);
int iflFileConfigIsDataTypeDefaulted(iflFileConfig *);
int iflFileConfigIsOrderDefaulted(iflFileConfig *);
int iflFileConfigIsColorModelDefaulted(iflFileConfig *);
int iflFileConfigIsOrientationDefaulted(iflFileConfig *);
int iflFileConfigIsCompressionDefaulted(iflFileConfig *);
int iflFileConfigArePageDimensionsDefaulted(iflFileConfig *);
iflFileDesc *iflFileDescCreate(const char *, iflFormat *);
iflFileDesc *iflFileDescPreParsed(const char *, int, const char *, const char *);
iflFileDesc *iflFileDescFullyParsed(const char *, int, iflFormat *, const char *);
void iflFileDescDelete(iflFileDesc *);
iflStatus iflFileDescGetStatus(iflFileDesc *);
const char* iflFileDescGetFileName(iflFileDesc *);
int iflFileDescGetFileDesc(iflFileDesc *);
int iflFileDescGetIndex(iflFileDesc *);
const char* iflFileDescGetFormatName(iflFileDesc *);
iflFormat* iflFileDescGetFormat(iflFileDesc *);
const char* iflFileDescGetFormatSpecific(iflFileDesc *);
void iflFileDescSetFileDesc(iflFileDesc *, int);
iflFormat* iflFormatFindNext(int *, int);
iflFormat* iflFormatFindByMagic(int, int);
iflFormat* iflFormatFindByFormatName(const char *, int);
iflFormat* iflFormatFindByFileName(const char *, int, int);
const char* iflFormatGetName(iflFormat *);
const char* iflFormatGetDefaultSuffix(iflFormat *);
const char* iflFormatGetDescription(iflFormat *);
int iflFormatAccessModeIsSupported(iflFormat *, int);
int iflFormatTypeIsSupported(iflFormat *, iflDataType);
int iflFormatOrderIsSupported(iflFormat *, iflOrder);
int iflFormatOrientationIsSupported(iflFormat *, iflOrientation);
int iflFormatColorModelIsSupported(iflFormat *, iflColorModel);
int iflFormatCompressionIsSupported(iflFormat *, iflCompression);
int iflFormatSizeIsSupported(iflFormat *, int, int, int, int, iflOrientation);
int iflFormatPagingIsSupported(iflFormat *);
int iflFormatPageSizeIsSupported(iflFormat *, int, int, int, int, int, int, int, int, iflOrientation);
int iflFormatRandomAccessReadIsSupported(iflFormat *);
int iflFormatRandomAccessWriteIsSupported(iflFormat *);
iflDataType iflFormatGetPreferredType(iflFormat *);
iflOrder iflFormatGetPreferredOrder(iflFormat *);
iflOrientation iflFormatGetPreferredOrientation(iflFormat *);
iflColorModel iflFormatGetPreferredColorModel(iflFormat *, int);
iflCompression iflFormatGetPreferredCompression(iflFormat *);
void iflFormatGetPreferredPageSize(iflFormat *, int, int, int, int, int *, int *, int *, int *, iflOrientation);
iflStatus iflFormatApplyDefaults(iflFormat *, iflFile *, iflFileConfig *);
iflStatus iflFormatApplyDefaultsConfig(iflFormat *, iflFileConfig *, iflFileConfig *);
iflTagDescription* iflFormatGetTagDescriptions(iflFormat *, int *);
int iflFormatHaveDSOVersion(iflFormat *, int, int);
iflLut *iflLutCreate(int, iflDataType, double, double, int);
iflLut *iflLutNoAlloc(void *, int, iflDataType, double, double, int);
iflLut *iflLutCopy(const iflLut *);
void iflLutDelete(iflLut *);
int iflLutGetNumChans(iflLut *);
iflDataType iflLutGetDataType(iflLut *);
int iflLutGetLength(iflLut *);
double iflLutGetVal(iflLut *, double, int);
iflStatus iflLutSetVal(iflLut *, double, double, int);
void* iflLutGetOrigin(iflLut *, int);
void* iflLutGetChan(iflLut *, int);
void* iflLutGetData(iflLut *);
void iflLutSetData(iflLut *, void *);
void iflLutGetDomain(iflLut *, double *, double *);
double iflLutGetDomainMin(iflLut *);
double iflLutGetDomainMax(iflLut *);
double iflLutGetDomainStep(iflLut *);
void iflLutGetRange(iflLut *, double *, double *);
iflStatus iflLutSetDomain(iflLut *, double, double);
int iflLutIsDiff(iflLut *, const iflLut *);
iflPixel *iflPixelCreate(iflDataType, int, const void *);
iflPixel *iflPixelPixCreate(const iflPixel *);
void iflPixelDelete(iflPixel *);
void iflPixelSet(iflPixel *, iflDataType, int, const void *);
void iflPixelConvert(iflPixel *, const iflPixel *, iflDataType, int, int *);
double iflPixelGetElem(iflPixel *, int);
void iflPixelSetElem(iflPixel *, double, int);
double iflPixelMin(iflPixel *);
double iflPixelMax(iflPixel *);
int iflPixelGetNumChans(iflPixel *);
iflDataType iflPixelGetDataType(iflPixel *);
void* iflPixelGetData(iflPixel *);
iflSGIColormap *iflSGIColormapCreate(void);
enum iflTagFlags {
    iflTagParamCountMask=0xf,
    iflTagNoParams=0,
    iflTagOneParam=1,
    iflTagTwoParams=2,
    iflTagThreeParams=3,
    iflTagFourParams=4,
    iflTagFiveParams=5,
    iflTagTypeMask=0xf0,
    iflTagShort=0x00,
    iflTagInt=0x10,
    iflTagFloat=0x20,
    iflTagString=0x30,
    iflTagBoolean=0x40,
    iflTagShortEnum=0x50,
    iflTagEnum=0x60,
    iflTagIntRange=0x70,
    iflTagFloatRange=0x80,
    iflTagDouble=0x90,
    iflTagDoubleRange=0xa0,
    iflTagGet=0x100,
    iflTagSet=0x200,
    iflTagOpen=0x1000,
    iflTagCreate=0x2000,
    iflTagInfo=0x4000,
    iflTagHide=0x10000
};
iflTag *iflTagFromDesc(iflTagDescription *);
void iflTagDelete(iflTag *);
void iflTagInit(iflTag *, iflTagDescription *);
void* iflTagGetValue(iflTag *);
int iflTagGetType(iflTag *);
int iflTagGetCount(iflTag *);
iflStatus iflTagRead(iflTag *, iflFile *);
iflStatus iflTagWrite(iflTag *, iflFile *);
iflStatus iflTagEncode(iflTag *, char *);
iflStatus iflTagDecode(iflTag *, const char *);
iflStatus iflFileGetTag(iflFile *, int, ...);
iflStatus iflFileSetTag(iflFile *, int, ...);
iflStatus iflFileGetItem(iflFile *, int, ...);	/* deprecated */
iflStatus iflFileSetItem(iflFile *, int, ...);	/* deprecated */
#endif
